import java.lang.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import java.awt.Color;

class graphs {
  menu_swing parent;
  private int lengthOfTask;
  private int current = 0;

  Connection conn;
  Statement stat;

  String aQuery;
  String aYear;
  String aMonth;
  String aDay;
  String fromDay;
  String toDay;
  String name;

  String url;
  String driver;
  String user;
  String password;

  private boolean isIllustra = false;
  private boolean isOracle = false;
  private boolean isDefault = true;

  SwingWorker worker;

  public graphs(menu_swing menu) {
    lengthOfTask = 100;
    this.parent = menu;
    setBooleanDB(parent.getWhichDB());
  }

  public void setBooleanDB(String aDB) {
    if (aDB == "Illustra") {
      isIllustra = true;
      isOracle = false;
      isDefault = false;
    }
    else if (aDB == "Oracle") {
      isIllustra = false;
      isOracle = true;
      isDefault = false;
    }
    else {
      System.out.println("Default DB selection.");
      isIllustra = false;
      isOracle = false;
      isDefault = true;
    }
  }

  public void openDB(String anURL, String anID, String aPassword) {
    url = anURL;
    user = anID;
    password = aPassword;

    if (isIllustra) {
      //url = "jdbc:mijdbc://sandman.npac.syr.edu:7531/GIS";
      driver = "mijdbc.MIDriver";
      //user = "miadmin";
      //password = "";
    }
    else if (isOracle) {
      //url = "jdbc:oracle:oci7:";
      driver = "oracle.jdbc.driver.OracleDriver";
      //user = "deepak";
      //password = "deepak";
    }
    else {
      //System.out.println("There is no default DB selection.");
      url = "jdbc:oracle:oci7:";
      driver = "oracle.jdbc.driver.OracleDriver";
      user = "deepak";
      password = "deepak";
    }

    try {
      Class.forName( driver );      
      conn = DriverManager.getConnection(url, user, password);
      stat = conn.createStatement();
      parent.setDBOpen(true);
    }
    catch (ClassNotFoundException ex) {
      //System.err.println("Cannot find the database driver classes.");
      //System.err.println(ex);
      parent.showMessageDialog("Cannot find the database driver classes.");
    }
    catch (SQLException ex) {
      //System.err.println("Cannot connect to this database.");
      //System.err.println(ex);
      if (isDefault) {
        parent.showMessageDialog("Cannot connect to as a default DB on this computer.");
      }
      else {
        parent.showMessageDialog("Cannot connect to " + url + " as " + user);
      }
    }
  }

  public void closeDB() {
    try {
      stat.close();
      conn.close();
    }
    catch ( Exception e ) {
      System.err.println("Exception: "+e);
      e.printStackTrace();
    }
  }

  class aDayTask {
    aDayTask () {
      try {
        String	data;
        int	i;
        String query = "";
        String condition, timeCondition;

        FileOutputStream s = new FileOutputStream(name + ".sva");
        DataOutput aDO = new DataOutputStream(s);

        data = "1"+"\n"+"\r";
        StringBuffer line = new StringBuffer(data);
        aDO.writeBytes(line.toString());
        data = "1.0"+"\n"+"\r";
        line = new StringBuffer(data);
        aDO.writeBytes(line.toString());

        for (i = 0; i < 24; i++) {

          if (i < 10) {
            if (parent.isAll) {
              condition = Integer.toString(i);
            }
            else {
	      condition = "0"+Integer.toString(i);
            }
          }
	  else {
	    condition = Integer.toString(i);
	  }
          //Boolean aBoolean = new Boolean(parent.isAll);
          //System.out.println("isAll:" + aBoolean.toString() );
          if (parent.isAll) {
            //System.out.println("In isAll.... ");
            if (isIllustra) {
              query = "select Hour_" + condition + aQuery + "= '" + aDay + "';";
            }
            else if (isOracle || isDefault) {
              query = "select Hour_" + condition + aQuery + "= to_date('" +
                       aDay + "', 'mon dd yyyy')";
            }
            else {System.out.println("There is an error in DB all selection.");}
          }
          else if (isIllustra) {
            //System.out.println("No isAll***** ");
            query = aQuery + "'" + aDay + " " + condition + ":00:00' and " +
                    "'" + aDay + " " + condition + ":59:59';";
          }
          else if (isOracle || isDefault) {
            query = aQuery + "to_date('" + aDay + " " + condition + ":00:00', " +
                    "'mon dd yyyy hh24:mi:ss') and " + "to_date('" + aDay + " " +
                    condition + ":59:59', 'mon dd yyyy hh24:mi:ss')";
          }
          else {System.out.println("There is an error in DB selection.");}

          System.out.println("Query: " + query);
          parent.setMessage("Counting " + condition + " hour data.", Color.red);
          current = lengthOfTask * i / 24;
          //parent.setProgressBar(100 * i / 24);
          //parent.bp.barP.pBar.setValue(100 * i / 24);
          System.out.println("Progress-----" + current);
          ResultSet rs = stat.executeQuery(query);

          if ( rs.next() ) {
	    String s1 = rs.getString(1);
            data = Integer.toString(i)+" "+s1+"\n"+"\r";
            line = new StringBuffer(data);
	    System.out.println("Count from a query at "+condition+" is "+s1+".");
            aDO.writeBytes(line.toString());
          }
        }
        s.close();
        //conn.close();
        Runtime.getRuntime().exec("java SV " + name + ".sva");
        current = lengthOfTask;
        parent.setMessage("Please see the visualized graph.", Color.blue);
        parent.setCondition(0, "");
      }
      catch ( Exception e ) {
        System.err.println("Exception: "+e);
        e.printStackTrace();
      }
    }
  }

  class DailyTask {
    DailyTask() {
      try {
        String	data;
        int	i;
        String query = "";
        String condition;

        //this.parent = menu;

        Integer from = new Integer(fromDay);
        Integer to = new Integer(toDay);

        if (from.intValue() > to.intValue() ) {
          System.out.println("Illegal day period input.");
          System.exit(0);
        }

        FileOutputStream s = new FileOutputStream(name + ".sva");
        DataOutput aDO = new DataOutputStream(s);

        data = "1"+"\n"+"\r";
        StringBuffer line = new StringBuffer(data);
        aDO.writeBytes(line.toString());
        data = "1.0"+"\n"+"\r";
        line = new StringBuffer(data);
        aDO.writeBytes(line.toString());

        i = from.intValue();
        System.out.println("From: " + from.toString() + " To: " + to.toString());
        for (; i <= to.intValue() ; i++) {

          condition = Integer.toString(i);

          aDay = aMonth + " " + condition + " " + aYear;
          if (parent.isAll) {
            if (isIllustra) {
              query = aQuery + "= '" + aDay + "';";
            }
            else if (isOracle || isDefault) {
              query = aQuery + "= to_date('" + aDay + "', 'mon dd yyyy')";
            }
            else { System.out.println("There is an error in DB all selection."); }
          }
          else if (isIllustra) {
            query = aQuery + "'" + aDay + " 00:00:00' and " +
                  "'" + aDay + " 23:59:59';";
          }
          else if (isOracle || isDefault) {
            query = aQuery + "to_date('" + aDay + " 00:00:00', 'mon dd yyyy hh24:mi:ss') " +
                    "and to_date('" + aDay + " 23:59:59', 'mon dd yyyy hh24:mi:ss')";
          }
          else { System.out.println("There is an error in DB selection."); }
                    
          System.out.println("Query: " + query);
	  parent.setMessage("Counting " + condition + " of " + aMonth + " data.", Color.red);

          current = lengthOfTask * (i - from.intValue()) / (to.intValue() - from.intValue());
          System.out.println("Progress-----" + current);

          ResultSet rs = stat.executeQuery(query);

          if ( rs.next() ) {
	    String s1 = rs.getString(1);
            data = Integer.toString(i)+" "+s1+"\n"+"\r";
            line = new StringBuffer(data);
	    System.out.println("Count from a query at "+condition+" is "+s1+".");
            aDO.writeBytes(line.toString());
          }
        }
        s.close();
        //conn.close();
        Runtime.getRuntime().exec("java SV " + name + ".sva");
        current = lengthOfTask;
        parent.setMessage("Please see the visualized graph.", Color.blue);
        parent.setCondition(0, "");
      }
      catch ( Exception e ) {
        System.err.println("Exception: "+e);
        e.printStackTrace();
      }
    }
  }

  void go(String paQuery, String paDay, String pname) {
    aQuery = paQuery;
    aDay = paDay;
    name = pname;
    //setDBEnvironment();

    worker = new SwingWorker() {
      public Object construct() {
        return new aDayTask();
      }
    };
  }

  void go(String paQuery, String pname, String pfromDay, String ptoDay) {
    aQuery = paQuery;
    name = pname;
    fromDay = pfromDay;
    toDay = ptoDay;
    aMonth = parent.aMonth;
    aYear = parent.aYear;

    //setDBEnvironment();

    worker = new SwingWorker() {
      public Object construct() {
        return new DailyTask();
      }
    };
  }

  void stop() {
    current = lengthOfTask;
    //worker.stop();
    worker.destroy();
    //closeDB();
    parent.setCondition(0, "");
  }

  int getLengthOfTask() {
    return lengthOfTask;
  }

  int getCurrent() {
    return current;
  }

  boolean done() {
    if (current >= lengthOfTask) {
      //parent.stopButton.setEnabled(false);
      return true;
    }
    else
      return false;
  }
}